"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
var useSyncStore = function (subscribe, getSnapshot, getServerSnapshot) {
    var getIsomorphicSnapshot = typeof document !== "undefined"
        ? getSnapshot
        : getServerSnapshot !== null && getServerSnapshot !== void 0 ? getServerSnapshot : getSnapshot;
    var _a = React.useState(getIsomorphicSnapshot), state = _a[0], setState = _a[1];
    var onStoreChange = React.useCallback(function () { return setState(function () { return getIsomorphicSnapshot(); }); }, [getIsomorphicSnapshot]);
    // eslint-disable-next-line react-hooks/exhaustive-deps
    React.useEffect(function () { return subscribe(onStoreChange); }, [onStoreChange]);
    return state;
};
var __STORE_SENTINEL__ = {};
var createStoreContext = function (stateFactory) {
    var StoreContext = React.createContext(null);
    if (process.env.NODE_ENV !== "production")
        StoreContext.displayName = "StoreContext";
    var StoreProvider = function (props) {
        var store = React.useRef(__STORE_SENTINEL__);
        var subscribers = React.useRef(new Set());
        var getState = React.useCallback(function () { return store.current; }, []);
        var setState = React.useCallback(function (setter) {
            var newState = setter(store.current);
            store.current = newState;
            subscribers.current.forEach(function (cb) { return cb(); });
        }, []);
        // Lazy initialization
        if (store.current === __STORE_SENTINEL__)
            store.current = stateFactory(setState, getState);
        var subscribe = React.useCallback(function (onStoreChange) {
            subscribers.current.add(onStoreChange);
            return function () {
                subscribers.current.delete(onStoreChange);
            };
        }, []);
        var context = React.useMemo(function () { return ({ getState: getState, subscribe: subscribe }); }, [getState, subscribe]);
        return ((0, jsx_runtime_1.jsx)(StoreContext.Provider, __assign({ value: context }, { children: props.children }), void 0));
    };
    var useStore = function (selector) {
        var storeContext = React.useContext(StoreContext);
        if (!storeContext) {
            throw new Error("[@utilityjs/create-store-context]: You can only use `useStore` in a subtree of `<StoreProvider>`.");
        }
        var getState = storeContext.getState, subscribe = storeContext.subscribe;
        var getSnapshot = React.useCallback(function () { return selector(getState()); }, 
        // eslint-disable-next-line react-hooks/exhaustive-deps
        [selector]);
        return useSyncStore(subscribe, getSnapshot, getSnapshot);
    };
    return { useStore: useStore, StoreProvider: StoreProvider };
};
exports.default = createStoreContext;
